# Test Pygame's sprite groups with a moving camera effect
# Copyright (C) 2010  Sylvain Beucler
#
# This file is part of GunDuck Force IV.
# 
# GunDuck Force IV is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
# 
# GunDuck Force IV is distributed in the hope that it will be fun,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# 
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SCREEN_W=640
SCREEN_H=480

import random

from pygame import *
init()
display.set_mode((SCREEN_W,SCREEN_H), DOUBLEBUF)

class Ship(sprite.Sprite):
    x = 0.0
    y = 0.0
    layer = 0
    def __init__(self, *args):
        super(Ship, self).__init__(*args)
        self.image = image.load("../share/gunduck/ship.png")
        self.x = random.randint(0, SCREEN_W-1)
        self.y = random.randint(0, SCREEN_H-1)
        
    # Handle offset
    def get_rect(self):
        global camera
        return Rect(int(self.x - camera.x), int(self.y - camera.y), 0, 0)
    rect = property(get_rect)


all = sprite.LayeredUpdates()
for i in range(0, 100):
    s = Ship(all)

camera = Rect(0,0,0,0)

is_running = True
clock = time.Clock()
while is_running:
    clock.tick()
    camera.x += 1
    display.get_surface().fill(0)
    all.draw(display.get_surface())
    display.flip()
    for ev in event.get():
        if ev.type == QUIT:
            is_running = False
        elif ev.type == KEYDOWN:
            if ev.key == K_ESCAPE:
                is_running = False
print clock.get_fps()
